%define name spruce
%define version 0.7.7
%define release 1
%define prefix /usr/local

Summary: Spruce is a Gtk+-based e-mail client supporting local spools, POP3 and IMAP.
Name: %{name}
Version: %{version}
Release: %{release}
Copyright: GPL
Group: Applications/Internet
Source: ftp://spruce.sourceforge.net/pub/spruce/devel/spruce-%{version}.tar.gz
BuildRoot: /var/tmp/%{name}-%{version}-buildroot
Prefix: %{prefix}
Docdir: %{prefix}/doc
Requires: gtk+ >= 1.2.6
Requires: glib >= 1.2.7

%description
Spruce is a Gtk+-based e-mail client designed to provide all of the basic
features people have grown to need.  Spruce may be used to receive mail 
from local mail spools, POP3 accounts and IMAP accounts.  PGP and 
GNU Privacy Guard are supported for secure, encrypted communications.
MIME attachment support and a powerful filtering capability (including
plain text matching, regular expressions support and shell wildcards) help
to make Spruce a powerful tool.  Its simple GUI design and available set of
NLS translations make spruce an easy-to-use tool for everyone.


%prep

%setup
if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --prefix=%prefix --enable-pgp --enable-gnome
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%prefix --enable-pgp --enable-gnome
fi

%build
make

%install
rm -rf $RPM_BUILD_ROOT
make prefix=$RPM_BUILD_ROOT%{prefix} install
gzip -9 $RPM_BUILD_ROOT%{prefix}/man/man1/spruce.1

%clean
rm -rf $RPM_BUILD_ROOT

%post

%postun

%files
%defattr (-, root, root)
%doc ABOUT-NLS AUTHORS COPYING ChangeLog INSTALL NEWS 
%doc README README.freebsd README.hacking README.mbox README.redhat 
%doc README.tools THANKS TODO WISHLIST sprucesig.sample
%doc tools doc/html
%{prefix}/man/man1/spruce.1.gz
%{prefix}/share/locale/*/LC_MESSAGES/spruce.mo
%attr(0755, root, root) %{prefix}/bin/spruce

%changelog

* Sun Aug 13 2000 Jacob Moorman <roguemtl@marblehorse.org>
- Permissions updates, move to spec.in

* Sun Aug 13 2000 Jacob Moorman <roguemtl@marblehorse.org>
- Initial RPM cretion
