/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __DATE_H__
#define __DATE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <glib.h>
#undef MIN
#undef MAX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

typedef struct
{
	gint day_of_week;
	gint day;
	gint month;
	gint year;
	gint hour;
	gint minute;
	gint second;
	gdouble original_tz_offset;
	gint bestguess;
} date_t;

gint get_days_in_month (gint month, gint year);

gint weekday_toi (gchar *string);
gchar *ito_weekday (int weekday);

gint month_toi (gchar *string);
gchar *ito_month (gint month);

gdouble rfc1123_timezone_tod (gchar *timezonestring);
date_t adjust_date_t_for_timezone (date_t date);

date_t parse_rfc822_date (GList *tokens);
date_t parse_bestguess_date (GList *tokens);
date_t parse_date (gchar *datestr);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
