/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include "debug.h"

gchar *debug_get_uname_info()
{
	gchar *buf = NULL;
	struct utsname uts;
	
	if (uname(&uts) >= 0) {
		buf = g_strconcat("     System name: ", uts.sysname,
				  "\n         Release: ", uts.release,
				  "\n         Version: ", uts.version,
				  "\n        Hardware: ", uts.machine,
				  "\n       Node name: ", uts.nodename,
#if !defined (sun) && !defined (__FreeBSD__)
#ifdef USE_GNU
				  "\n     Domain name: ", uts.domainname,
#else
				  "\n     Domain name: ", uts.__domainname,
#endif
#endif
				  NULL);
	}
	
	return buf;
}

gchar *debug_get_lib_info()
{
	gchar *libs = NULL;
	
	libs = g_strdup_printf("    glib version: %d.%d.%d\n"
			       "     gtk version: %d.%d.%d\n"
			       "    libc version: %d.%d.%d",
			       GLIB_MAJOR_VERSION, GLIB_MINOR_VERSION, GLIB_MICRO_VERSION,
			       gtk_major_version, gtk_minor_version, gtk_micro_version,
			       2, 1, 0);
	
	return libs;
}

#if 0
gchar *debug_get_sys_info()
{
	gchar *sys = NULL;
	struct utsname uts;
	struct rlimit rlim;
	struct sysinfo s_info;
	
	if (uname(&uts) >= 0) {
		uname = g_strconcat("                      System name: ", uts.sysname,
				    "\n                          Release: ", uts.release,
				    "\n                          Version: ", uts.version,
				    "\n                         Hardware: ", uts.machine,
				    "\n                        Node name: ", uts.nodename,
#ifdef USE_GNU
				    "\n                      Domain name: ", uts.domainname,
#else
				    "\n                      Domain name: ", uts.__domainname,
#endif
				    NULL);
	}
	
	return sys;
}
#endif

