/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include "edit-menu.h"

void on_mnuEditCut_activate (GtkWidget *widget, gpointer user_data)
{
	GtkWidget *text = get_widget(widget, "txtBody");  /* from composer */

	if (!text)
		text = get_widget(widget, "txtMessage");  /* from main window */

	gtk_editable_cut_clipboard(GTK_EDITABLE(text));
}

void on_mnuEditCopy_activate (GtkWidget *widget, gpointer user_data)
{
	GtkWidget *text = get_widget(widget, "txtBody");  /* from composer */

	if (!text)
		text = get_widget(widget, "txtMessage");  /* from main window */

	gtk_editable_copy_clipboard(GTK_EDITABLE(text));
}

void on_mnuEditPaste_activate (GtkWidget *widget, gpointer user_data)
{
	GtkWidget *text = get_widget(widget, "txtBody");  /* from composer */

	if (!text)
		text = get_widget(widget, "txtMessage");  /* from main window */

	gtk_editable_paste_clipboard(GTK_EDITABLE(text));
}
