/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  Authors: Jeffrey Stedfast <fejj@helixcode.com>
 *           Kristoffer Brnemyr <ztion@swipnet.se>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, 
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include "filters.h"
#include <regex.h>
#include <fnmatch.h>

/* external variables */
extern gchar *spruceconf;                /* spruce config file name */
extern GtkWidget *frmFilters;
extern gboolean FiltersOpen;             /* is frmFilters opened?? */
extern GtkWidget *frmMain;


GtkWidget *dlgNewFilter;
GList *filters_mailboxes = NULL;
extern GList *filters;

GtkWidget* create_frmFilters ()
{
	GtkWidget *frmFilters;
	GtkWidget *fixed1;
	GtkWidget *cmdFiltersOK;
	GtkWidget *cmdFiltersApply;
	GtkWidget *cmdFiltersCancel;
	GtkWidget *frame2;
	GtkWidget *fixed3;
	GtkWidget *action_move_combo;
	GSList *action_button_group = NULL;
	GtkWidget *action_move_button;
	GtkWidget *action_forward_button;
	GtkWidget *action_forward_entry;
	GtkWidget *action_delete_button;
	GtkWidget *frameMatch;
	GtkWidget *fixed2;
	GtkWidget *negate_expr_button;
	GtkWidget *lblMatchIn;
	GtkWidget *match_text_entry;
	GtkWidget *lblMatchText;
	GtkWidget *match_in_combo;
	GtkWidget *lblMatchType;
	GtkWidget *match_type_combo;
	GtkWidget *frame3;
	GtkWidget *fixed4;
	GtkWidget *scrolledwindow1;
	GtkWidget *filters_clist;
	GtkWidget *lblFilter;
	GtkWidget *cmdFiltersNew;
	GtkWidget *cmdFiltersDelete;
	GtkWidget *hseparator1;
	GList *match_in_combo_opts = NULL;
	GList *match_type_combo_opts = NULL;

	frmFilters = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_name (frmFilters, "frmFilters");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "frmFilters", frmFilters);
	gtk_widget_set_usize (frmFilters, 532, 360);
	gtk_container_border_width (GTK_CONTAINER (frmFilters), 4);
	gtk_signal_connect_object (GTK_OBJECT (frmFilters), "destroy",
				   GTK_SIGNAL_FUNC (on_frmFilters_destroy),
				   GTK_OBJECT (frmFilters));
	gtk_window_set_title (GTK_WINDOW (frmFilters), _("Edit Filters"));
	gtk_window_position (GTK_WINDOW (frmFilters), GTK_WIN_POS_CENTER);
	gtk_window_set_policy (GTK_WINDOW (frmFilters), FALSE, FALSE, FALSE);

	fixed1 = gtk_fixed_new ();
	gtk_widget_set_name (fixed1, "fixed1");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "fixed1", fixed1);
	gtk_widget_show (fixed1);
	gtk_container_add (GTK_CONTAINER (frmFilters), fixed1);

	cmdFiltersOK = gtk_button_new_with_label (_("OK"));
	gtk_widget_set_name (cmdFiltersOK, "cmdFiltersOK");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "cmdFiltersOK", cmdFiltersOK);
	gtk_widget_show (cmdFiltersOK);
	gtk_fixed_put (GTK_FIXED (fixed1), cmdFiltersOK, 272, 314);
	gtk_widget_set_uposition (cmdFiltersOK, 272, 314);
	gtk_widget_set_usize (cmdFiltersOK, 72, 32);
	gtk_signal_connect_object (GTK_OBJECT (cmdFiltersOK), "clicked",
				   GTK_SIGNAL_FUNC (on_cmdFiltersOK_clicked),
				   GTK_OBJECT (frmFilters));

	cmdFiltersApply = gtk_button_new_with_label (_("Apply"));
	gtk_widget_set_name (cmdFiltersApply, "cmdFiltersApply");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "cmdFiltersApply", cmdFiltersApply);
	gtk_widget_show (cmdFiltersApply);
	gtk_fixed_put (GTK_FIXED (fixed1), cmdFiltersApply, 360, 314);
	gtk_widget_set_uposition (cmdFiltersApply, 360, 314);
	gtk_widget_set_usize (cmdFiltersApply, 72, 32);
	gtk_signal_connect_object (GTK_OBJECT (cmdFiltersApply), "clicked",
				   GTK_SIGNAL_FUNC (on_cmdFiltersApply_clicked),
				   GTK_OBJECT (frmFilters));

	cmdFiltersCancel = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_set_name (cmdFiltersCancel, "cmdFiltersCancel");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "cmdFiltersCancel", cmdFiltersCancel);
	gtk_widget_show (cmdFiltersCancel);
	gtk_fixed_put (GTK_FIXED (fixed1), cmdFiltersCancel, 448, 314);
	gtk_widget_set_uposition (cmdFiltersCancel, 448, 314);
	gtk_widget_set_usize (cmdFiltersCancel, 72, 32);
	gtk_signal_connect_object (GTK_OBJECT (cmdFiltersCancel), "clicked",
				   GTK_SIGNAL_FUNC (on_cmdFiltersCancel_clicked),
				   GTK_OBJECT (frmFilters));

	frame2 = gtk_frame_new (_("Action"));
	gtk_widget_set_name (frame2, "frame2");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "frame2", frame2);
	gtk_widget_show (frame2);
	gtk_fixed_put (GTK_FIXED (fixed1), frame2, 8, 168);
	gtk_widget_set_uposition (frame2, 8, 168);
	gtk_widget_set_usize (frame2, 304, 128);

	fixed3 = gtk_fixed_new ();
	gtk_widget_set_name (fixed3, "fixed3");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "fixed3", fixed3);
	gtk_widget_show (fixed3);
	gtk_container_add (GTK_CONTAINER (frame2), fixed3);

	action_move_combo = gtk_combo_new ();
	gtk_widget_set_name (action_move_combo, "action_move_combo");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "action_move_combo", action_move_combo);
	gtk_signal_connect (GTK_OBJECT (GTK_COMBO (action_move_combo)->button), "pressed",
			   GTK_SIGNAL_FUNC (on_cmdFiltersMoveComboButton_clicked), NULL);
	gtk_widget_show (action_move_combo);
	gtk_fixed_put (GTK_FIXED (fixed3), action_move_combo, 128, 8);
	gtk_widget_set_uposition (action_move_combo, 128, 8);
	gtk_widget_set_usize (GTK_COMBO (action_move_combo)->entry, 144, 24);
	gtk_widget_set_usize (action_move_combo, 160, 24);

	action_move_button = gtk_radio_button_new_with_label (action_button_group, _("Move to folder:"));
	action_button_group = gtk_radio_button_group (GTK_RADIO_BUTTON (action_move_button));
	gtk_widget_set_name (action_move_button, "action_move_button");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "action_move_button", action_move_button);
	gtk_widget_show (action_move_button);
	gtk_fixed_put (GTK_FIXED (fixed3), action_move_button, 8, 8);
	gtk_widget_set_uposition (action_move_button, 8, 8);
	gtk_widget_set_usize (action_move_button, 120, 24);
	gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (action_move_button), TRUE);

	action_forward_button = gtk_radio_button_new_with_label (action_button_group, _("Forward to:"));
	action_button_group = gtk_radio_button_group (GTK_RADIO_BUTTON (action_forward_button));
	gtk_widget_set_name (action_forward_button, "action_forward_button");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "action_forward_button", action_forward_button);
	gtk_widget_show (action_forward_button);
	gtk_fixed_put (GTK_FIXED (fixed3), action_forward_button, 8, 40);
	gtk_widget_set_uposition (action_forward_button, 8, 40);
	gtk_widget_set_usize (action_forward_button, 112, 24);

	action_forward_entry = gtk_entry_new ();
	gtk_widget_set_name (action_forward_entry, "action_forward_entry");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "action_forward_entry", action_forward_entry);
	gtk_widget_show (action_forward_entry);
	gtk_fixed_put (GTK_FIXED (fixed3), action_forward_entry, 128, 40);
	gtk_widget_set_uposition (action_forward_entry, 128, 40);
	gtk_widget_set_usize (action_forward_entry, 158, 22);

	action_delete_button = gtk_radio_button_new_with_label (action_button_group, _("Delete message"));
	action_button_group = gtk_radio_button_group (GTK_RADIO_BUTTON (action_delete_button));
	gtk_widget_set_name (action_delete_button, "action_delete_button");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "action_delete_button", action_delete_button);
	gtk_widget_show (action_delete_button);
	gtk_fixed_put (GTK_FIXED (fixed3), action_delete_button, 8, 72);
	gtk_widget_set_uposition (action_delete_button, 8, 72);
	/* we might as well use the whole space, so translations fit */
	/*gtk_widget_set_usize (action_delete_button, 120, 24);*/

	frameMatch = gtk_frame_new (_("Match"));
	gtk_widget_set_name (frameMatch, "frameMatch");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "frameMatch", frameMatch);
	gtk_widget_show (frameMatch);
	gtk_fixed_put (GTK_FIXED (fixed1), frameMatch, 8, 8);
	gtk_widget_set_uposition (frameMatch, 8, 8);
	gtk_widget_set_usize (frameMatch, 304, 156);

	fixed2 = gtk_fixed_new ();
	gtk_widget_set_name (fixed2, "fixed2");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "fixed2", fixed2);
	gtk_widget_show (fixed2);
	gtk_container_add (GTK_CONTAINER (frameMatch), fixed2);

	negate_expr_button = gtk_check_button_new_with_label (_("Match if text is NOT found"));
	gtk_widget_set_name (negate_expr_button, "negate_expr_button");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "negate_expr_button", negate_expr_button);
	gtk_widget_show (negate_expr_button);
	gtk_fixed_put (GTK_FIXED (fixed2), negate_expr_button, 8, 4);
	gtk_widget_set_uposition (negate_expr_button, 8, 4);


	lblMatchIn = gtk_label_new (_("In:"));
	gtk_widget_set_name (lblMatchIn, "lblMatchIn");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "lblMatchIn", lblMatchIn);
	gtk_widget_show (lblMatchIn);
	gtk_fixed_put (GTK_FIXED (fixed2), lblMatchIn, 8, 68);
	gtk_widget_set_uposition (lblMatchIn, 8, 68);
	gtk_widget_set_usize (lblMatchIn, 56, 24);
	gtk_label_set_justify (GTK_LABEL (lblMatchIn), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (lblMatchIn), 1.93715e-07, 0.5);

	match_text_entry = gtk_entry_new ();
	gtk_widget_set_name (match_text_entry, "match_text_entry");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "match_text_entry", match_text_entry);
	gtk_widget_show (match_text_entry);
	gtk_fixed_put (GTK_FIXED (fixed2), match_text_entry, 72, 36);
	gtk_widget_set_uposition (match_text_entry, 72, 36);
	gtk_widget_set_usize (match_text_entry, 216, 24);
        gtk_widget_grab_focus (match_text_entry);
   
	lblMatchText = gtk_label_new (_("Text:"));
	gtk_widget_set_name (lblMatchText, "lblMatchText");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "lblMatchText", lblMatchText);
	gtk_widget_show (lblMatchText);
	gtk_fixed_put (GTK_FIXED (fixed2), lblMatchText, 8, 36);
	gtk_widget_set_uposition (lblMatchText, 8, 36);
	gtk_widget_set_usize (lblMatchText, 56, 24);
	gtk_label_set_justify (GTK_LABEL (lblMatchText), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (lblMatchText), 1.93715e-07, 0.5);

	match_in_combo = gtk_combo_new ();
	gtk_widget_set_name (match_in_combo, "match_in_combo");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "match_in_combo", match_in_combo);
	/* these should do by default */
	match_in_combo_opts = g_list_append (match_in_combo_opts, "To:");
	match_in_combo_opts = g_list_append (match_in_combo_opts, "From:");
	match_in_combo_opts = g_list_append (match_in_combo_opts, "Sender:");
	match_in_combo_opts = g_list_append (match_in_combo_opts, "Subject:");
	match_in_combo_opts = g_list_append (match_in_combo_opts, "Cc:");
	match_in_combo_opts = g_list_append (match_in_combo_opts, "Reply-To:");
	match_in_combo_opts = g_list_append (match_in_combo_opts, "Any recipient");
	gtk_combo_set_popdown_strings (GTK_COMBO (match_in_combo), match_in_combo_opts);
	gtk_widget_show (match_in_combo);
	gtk_fixed_put (GTK_FIXED (fixed2), match_in_combo, 72, 68);
	gtk_widget_set_uposition (match_in_combo, 72, 68);
	gtk_widget_set_usize (GTK_COMBO (match_in_combo)->entry, 200, 24);
	gtk_widget_set_usize (match_in_combo, 216, 24);
	
	lblMatchType = gtk_label_new (_("Type:"));
	gtk_widget_set_name (lblMatchType, "lblMatchType");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "lblMatchType", lblMatchType);
	gtk_widget_show (lblMatchType);
	gtk_fixed_put (GTK_FIXED (fixed2), lblMatchType, 8, 100);
	gtk_widget_set_uposition (lblMatchType, 8, 100);
	gtk_widget_set_usize (lblMatchType, 56, 24);
	gtk_label_set_justify (GTK_LABEL (lblMatchType), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (lblMatchType), 1.93715e-07, 0.5);
	
	match_type_combo = gtk_combo_new ();
	gtk_widget_set_name (match_type_combo, "match_type_combo");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "match_type_combo", 
			     match_type_combo);
	match_type_combo_opts = g_list_append (match_type_combo_opts, "Normal");
	match_type_combo_opts = g_list_append (match_type_combo_opts, "Regex");
	match_type_combo_opts = g_list_append (match_type_combo_opts, 
					       "Shell wildcards");
	gtk_combo_set_popdown_strings (GTK_COMBO (match_type_combo), 
				       match_type_combo_opts);
	gtk_widget_show (match_type_combo);
	gtk_fixed_put (GTK_FIXED (fixed2), match_type_combo, 72, 100);
	gtk_widget_set_uposition (match_type_combo, 72, 100);
	gtk_widget_set_usize (GTK_COMBO (match_type_combo)->entry, 200, 24);
	gtk_widget_set_usize (match_type_combo, 216, 24);
	
	frame3 = gtk_frame_new (_("Filters"));
	gtk_widget_set_name (frame3, "frame3");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "frame3", frame3);
	gtk_widget_show (frame3);
	gtk_fixed_put (GTK_FIXED (fixed1), frame3, 320, 8);
	gtk_widget_set_uposition (frame3, 320, 8);
	gtk_widget_set_usize (frame3, 200, 288);
	
	fixed4 = gtk_fixed_new ();
	gtk_widget_set_name (fixed4, "fixed4");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "fixed4", fixed4);
	gtk_widget_show (fixed4);
	gtk_container_add (GTK_CONTAINER (frame3), fixed4);
	
	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "scrolledwindow1", scrolledwindow1);
	gtk_widget_show (scrolledwindow1);
	gtk_fixed_put (GTK_FIXED (fixed4), scrolledwindow1, 8, 0);
	gtk_widget_set_uposition (scrolledwindow1, 8, 0);
	gtk_widget_set_usize (scrolledwindow1, 184, 230);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
					GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	filters_clist = gtk_clist_new (1);
	gtk_widget_set_name (filters_clist, "filters_clist");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "filters_clist", filters_clist);
	gtk_signal_connect (GTK_OBJECT (filters_clist), "select_row", GTK_SIGNAL_FUNC (on_clistrow_selected), NULL);
	gtk_widget_show (filters_clist);
	gtk_container_add (GTK_CONTAINER (scrolledwindow1), filters_clist);
	gtk_clist_set_column_width (GTK_CLIST (filters_clist), 0, 80);
	gtk_clist_column_titles_show (GTK_CLIST (filters_clist));
	
	lblFilter = gtk_label_new (_("Filter"));
	gtk_widget_set_name (lblFilter, "lblFilter");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "lblFilter", lblFilter);
	gtk_widget_show (lblFilter);
	gtk_clist_set_column_widget (GTK_CLIST (filters_clist), 0, lblFilter);
	
	cmdFiltersNew = gtk_button_new_with_label (_("New"));
	gtk_widget_set_name (cmdFiltersNew, "cmdFiltersNew");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "cmdFiltersNew", cmdFiltersNew);
	gtk_widget_show (cmdFiltersNew);
	gtk_fixed_put (GTK_FIXED (fixed4), cmdFiltersNew, 16, 238);
	gtk_widget_set_uposition (cmdFiltersNew, 16, 238);
	gtk_widget_set_usize (cmdFiltersNew, 72, 24);
	gtk_signal_connect (GTK_OBJECT (cmdFiltersNew), "clicked",
			    GTK_SIGNAL_FUNC (on_cmdFiltersNew_clicked),
			    NULL);
	
	cmdFiltersDelete = gtk_button_new_with_label (_("Delete"));
	gtk_widget_set_name (cmdFiltersDelete, "cmdFiltersDelete");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "cmdFiltersDelete", cmdFiltersDelete);
	gtk_widget_show (cmdFiltersDelete);
	gtk_fixed_put (GTK_FIXED (fixed4), cmdFiltersDelete, 112, 238);
	gtk_widget_set_uposition (cmdFiltersDelete, 112, 238);
	gtk_widget_set_usize (cmdFiltersDelete, 72, 24);
	gtk_signal_connect (GTK_OBJECT (cmdFiltersDelete), "clicked",
			    GTK_SIGNAL_FUNC (on_cmdFiltersDelete_clicked),
			    NULL);
	
	hseparator1 = gtk_hseparator_new ();
	gtk_widget_set_name (hseparator1, "hseparator1");
	gtk_object_set_data (GTK_OBJECT (frmFilters), "hseparator1", hseparator1);
	gtk_widget_show (hseparator1);
	gtk_fixed_put (GTK_FIXED (fixed1), hseparator1, 0, 298);
	gtk_widget_set_uposition (hseparator1, 0, 298);
	gtk_widget_set_usize (hseparator1, 520, 16);
	
	return frmFilters;
}
 
GtkWidget *create_dlgNewFilter (void)
{
	GtkWidget *dlgNewFilter;
	GtkWidget *box1;
	GtkWidget *newfilter_entry;
	GtkWidget *label;
	GtkWidget *button;
	
	dlgNewFilter = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (dlgNewFilter), _("Name of the Filter?"));
	gtk_widget_set_usize (dlgNewFilter, 300, 100);
	gtk_container_set_border_width (GTK_CONTAINER (dlgNewFilter), 10);
	
	box1 = gtk_vbox_new (FALSE, FALSE);
	gtk_widget_show (box1);
	gtk_container_add (GTK_CONTAINER (dlgNewFilter), box1);
	
	label = gtk_label_new (_("Name of the Filter?"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
	
	newfilter_entry = gtk_entry_new ();
	gtk_widget_set_name (newfilter_entry, "newfilter_entry");
	gtk_object_set_data (GTK_OBJECT (dlgNewFilter), "newfilter_entry", newfilter_entry);
	gtk_box_pack_start (GTK_BOX (box1), newfilter_entry, FALSE, FALSE, 0);
	gtk_widget_show (newfilter_entry);
        gtk_widget_grab_focus (newfilter_entry);	
   
	button = gtk_button_new_with_label(_("Ok"));
	gtk_widget_show (button);
	gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (on_dlgNewFilterOk_clicked), NULL);
	gtk_box_pack_end (GTK_BOX (box1), button, FALSE, FALSE, 0);
	
	return dlgNewFilter;
 
}

void on_frmFilters_destroy (GtkObject *object, gpointer user_data)
{
	gtk_widget_destroy (frmFilters);
	FiltersOpen = FALSE;
}

void on_cmdFiltersCancel_clicked (GtkObject *object, gpointer user_data)
{
	gtk_widget_destroy (frmFilters);
	FiltersOpen = FALSE;
}

void on_dlgNewFilter_destroy (GtkObject *object, gpointer user_data)
{
	gtk_widget_destroy (dlgNewFilter);
}

void on_cmdFiltersOK_clicked (GtkWidget *object, gpointer user_data)
{
	filters_save ();
	gtk_widget_destroy (frmFilters);
	FiltersOpen = FALSE;
}
 
void on_cmdFiltersDelete_clicked (GtkWidget *object, gpointer user_data)
{
	GtkWidget *clist       = get_widget (frmFilters, "filters_clist");
	GtkWidget *match_entry = get_widget (frmFilters, "match_text_entry");
	GtkWidget *in_combo    = get_widget (frmFilters, "match_in_combo");
	GtkWidget *type_combo  = get_widget (frmFilters, "match_type_combo");
	GtkWidget *move_combo  = get_widget (frmFilters, "action_move_combo");
	GtkWidget *forward_entry = get_widget (frmFilters, "action_forward_entry");
	GtkWidget *move_button = get_widget (frmFilters, "action_move_button");
	GList *selection;
	
	selection = GTK_CLIST (clist)->selection;
	if (selection == NULL)
		return;
	
	gtk_clist_freeze (GTK_CLIST (clist));
	filters = g_list_remove (filters, g_list_nth_data (filters, (gint)selection->data));
	gtk_clist_remove (GTK_CLIST (clist), (gint)selection->data);
	gtk_clist_thaw (GTK_CLIST (clist));
	
	gtk_entry_set_text (GTK_ENTRY (match_entry), "");
	gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (in_combo)->entry), "");
	gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (type_combo)->entry), "");
	gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (move_combo)->entry), "");
	gtk_entry_set_text (GTK_ENTRY (forward_entry), "");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (move_button), 1);
	
	/*filters_refresh ();
	  rc_save_defaults ();*/
}
 
void on_cmdFiltersNew_clicked (GtkWidget *ob, gpointer user_data)
{
	dlgNewFilter = create_dlgNewFilter ();
	gtk_widget_show (dlgNewFilter);
}
 
void on_cmdFiltersApply_clicked (GtkWidget *ob, gpointer user_data)
{
	filters_save ();
}
 
void on_cmdFiltersMoveComboButton_clicked (GtkWidget *ob, gpointer user_data)
{
	gchar *box;
	GtkWidget *combo = get_widget (frmFilters, "action_move_combo");
	GtkWidget *treelocalBoxes = get_widget (frmMain, "treelocalBoxes");
	GtkWidget *label;
	GList *items;
	
	if (filters_mailboxes != NULL) {
		g_list_free (filters_mailboxes);
		filters_mailboxes = NULL;
	}
	
	items = GTK_TREE (treelocalBoxes)->children;
	while (items != NULL) {
		label = gtk_object_get_data (GTK_OBJECT (items->data), "label");
		gtk_label_get (GTK_LABEL (label), &box);
		filters_mailboxes = g_list_append (filters_mailboxes, box);
		items = items->next;
	}
	
	if (filters_mailboxes)
		gtk_combo_set_popdown_strings (GTK_COMBO (combo), filters_mailboxes);
}
 
void on_clistrow_selected (GtkWidget *ob, gint row, gint column, GdkEventButton *event, gpointer user_data)
{
	struct filter *flt;
	GtkWidget *match_in       = get_widget (frmFilters, "match_in_combo");
	GtkWidget *match_type     = get_widget (frmFilters, "match_type_combo");
	GtkWidget *match_text     = get_widget (frmFilters, "match_text_entry");
	GtkWidget *move_combo     = get_widget (frmFilters, "action_move_combo");
	GtkWidget *move_button    = get_widget (frmFilters, "action_move_button");
	GtkWidget *forward_entry  = get_widget (frmFilters, "action_forward_entry");
	GtkWidget *forward_button = get_widget (frmFilters, "action_forward_button");
	GtkWidget *delete_button  = get_widget (frmFilters, "action_delete_button");
	GtkWidget *negate_button  = get_widget (frmFilters, "negate_expr_button");
	
	flt = g_list_nth_data (filters, row);
	gtk_entry_set_text (GTK_ENTRY (match_text), flt->match);
	gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (match_in)->entry), flt->in);
	switch (flt->type) {
	case FLT_REGEX:
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (match_type)->entry), "Regex");
		break;
	case FLT_GLOB:
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (match_type)->entry), "Shell wildcards");
		break;
	case FLT_NORMAL:
		/* fall through */
	default:
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (match_type)->entry), "Normal");
		break;
	}
	
	switch (flt->action) {
	case 1:
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (move_button), 1);
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (move_combo)->entry), flt->to);
		gtk_entry_set_text (GTK_ENTRY (forward_entry), "");
		break;
	case 2:
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (forward_button), 1);
		gtk_entry_set_text (GTK_ENTRY (forward_entry), flt->to);
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (move_combo)->entry), "");
		break;
	case 3:
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (delete_button), 1);
		gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (move_combo)->entry), "");
		gtk_entry_set_text (GTK_ENTRY (forward_entry), "");
		break;
	default:
	}

	if (flt->negate == 1) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (negate_button), 1);
	} else {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (negate_button), 0);
	}
}
 
void on_dlgNewFilterOk_clicked (GtkWidget *ob, gpointer user_data)
{
	struct filter *flt;
	GtkWidget *entry = get_widget (dlgNewFilter, "newfilter_entry");
	GtkWidget *clist = get_widget (frmFilters, "filters_clist");
	gchar *name;
	
	name = gtk_entry_get_text (GTK_ENTRY (entry));
   
	if (name[0] != '\0') {
		flt = g_malloc0 (sizeof (struct filter));
		
		strncpy (flt->name, name, 64);
		filters = g_list_append (filters, flt);
		filters_refresh ();
		gtk_clist_select_row (GTK_CLIST (clist), GTK_CLIST (clist)->rows - 1, 0);
	}
	
	gtk_widget_destroy (dlgNewFilter);
}
 
void filters_save (void)
{
	GtkWidget *move_button    = get_widget (frmFilters, "action_move_button");
	GtkWidget *move_combo     = get_widget (frmFilters, "action_move_combo");
	GtkWidget *forward_button = get_widget (frmFilters, "action_forward_button");
	GtkWidget *forward_entry  = get_widget (frmFilters, "action_forward_entry");
	GtkWidget *delete_button  = get_widget (frmFilters, "action_delete_button");
	GtkWidget *match_text     = get_widget (frmFilters, "match_text_entry");
	GtkWidget *match_in       = get_widget (frmFilters, "match_in_combo");
	GtkWidget *match_type     = get_widget (frmFilters, "match_type_combo");
	GtkWidget *negate_button  = get_widget (frmFilters, "negate_expr_button");
	GtkWidget *clist          = get_widget (frmFilters, "filters_clist");
	GList *selection;
	GList *tmp;
	struct filter *flt;
	gint i = 0;
	
	selection = GTK_CLIST (clist)->selection;
	if (selection == NULL)
		return;
	tmp = filters;
	if (tmp == NULL)
		return;
	
	while (i < (gint)selection->data) {
		tmp = tmp->next;
		i++;
	}
	
	flt = tmp->data;
	strncpy (flt->match, gtk_entry_get_text (GTK_ENTRY (match_text)), 127);
	strncpy (flt->in, gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (match_in)->entry)), 127);
	if (!fnmatch ("Normal", gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (match_type)->entry)), 0))
		flt->type = 0;
	if (!fnmatch ("Regex", gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (match_type)->entry)), 0))
		flt->type = 1;
	if (!fnmatch ("Shell wildcards", gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (match_type)->entry)), 0))
		flt->type = 2;
	
	if (GTK_TOGGLE_BUTTON (move_button)->active) {
		flt->action = 1;
		strncpy (flt->to, gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (move_combo)->entry)), 127);
	}
	if (GTK_TOGGLE_BUTTON (forward_button)->active) {
		flt->action = 2;
		strncpy (flt->to, gtk_entry_get_text (GTK_ENTRY (forward_entry)), 127);
	}
	if (GTK_TOGGLE_BUTTON (delete_button)->active) {
		flt->action = 3;
	}

	if (GTK_TOGGLE_BUTTON (negate_button)->active) {
		flt->negate = 1;
	} else {
		flt->negate = 0;
	}
	rc_save_defaults ();
}
 
gint filters_read (void)
{
	gchar buffer[257];
	FILE *fp;
	gchar *name  = NULL;
	gchar *to    = NULL;
	gchar *match = NULL;
	gchar *in;
	gchar *negate = NULL;
	gint type, action, field;
	struct filter *flt;
	gchar delim;
	
	fp = fopen (spruceconf, "rt");
	if (fp == NULL) {
		fprintf (stderr, "Spruce: %s failed to open for reading.\n", spruceconf);
		fprintf (stderr, "Please check with your local Administrator.\n");
		return 0;
	}
	
	while (!feof (fp)) {
		fgets (buffer, 256, fp);
		g_strchug (buffer);
		if (buffer[0] != '\n' && buffer[0] != '#') {
			if (!strncmp ("filter", buffer, strlen ("filter"))) {
				char *buf;
				
				strcut (buffer, 0, strlen ("filter"));
				g_strstrip (buffer);
				
				/* keep compatability with old config (0.5.15 and earlier) files */
				if (get_num_fields (buffer, '~') >= 6) {
					delim = '~';
					field = 1;
				} else {
					delim = '^';
					field = 0;
				}
				
				name   = get_field (buffer, 1, delim);
				
				buf    = get_field (buffer, 2, '~');
				type   = delim == '~' ? atoi (buf) : FLT_NORMAL;
				g_free (buf);
				
				match  = get_field (buffer, 2 + field, delim);
				in     = get_field (buffer, 3 + field, delim);
				
				buf    = get_field (buffer, 4 + field, delim);
				action = atoi (buf);
				g_free (buf);
				
				to     = get_field (buffer, 5 + field, delim);
				
				flt = g_malloc0 (sizeof (struct filter));
				
				strncpy (flt->name, name, 63);
				g_free (name);
				
				flt->type = type;
				
				negate = get_field (buffer, 6 + field, delim);
				if (negate != NULL && strcmp (negate, "") != 0) {
					flt->negate = atoi (negate);
					g_free (negate);
				}
				else {
					negate = 0;
				}

				strncpy (flt->match, match, 127);
				g_free (match);
				
				strncpy (flt->in, in, 127);
				g_free (in);
				
				flt->action = action;
				
				strncpy (flt->to, to, 127);
				g_free (to);
				
				filters = g_list_append (filters, flt);
			}
		}
	}
	
	fclose (fp);
	return 1;
}
 
void filters_refresh (void)
{
	GtkWidget *clist;
	GList *tmp;
	struct filter *flt;
	int i = 1;
	gchar *text[1];
	
	clist = get_widget (frmFilters, "filters_clist");
	gtk_clist_clear (GTK_CLIST (clist));
	
	tmp = filters;
	while (tmp != NULL) {
		flt = tmp->data;
		text[0] = flt->name;
		gtk_clist_append (GTK_CLIST (clist), text);
		tmp = tmp->next;
		i++;
	}
}
 
/* returns 1 if a filter was found for the mail, otherwise 0. */
gint check_filters (gint fd)
{
	FILE *file;
	gint matched = 0;
	gchar buffer[512], c;
	gchar inmatch[256];
	struct filter *flt = NULL;
	gboolean next_field = FALSE;
	GList *tmp;
	regex_t regexpat;
	regmatch_t *fltmatch;
	gint regerr = 0;
	size_t reglen = 0;
	gchar *regmsg;
	Mailbox_t mailbox;
	
	file = fdopen (fd, "r");
	if (!file) {
		fprintf (stderr, _("Could not filter message.\n"));
		return 0;
	}
	
	fseek (file, 0, SEEK_SET);
	memset (buffer, 0, sizeof (buffer));
	
	tmp = filters;
	while (tmp != NULL) {
		flt = tmp->data;
		while ((fgets (buffer, sizeof (buffer)-1, file))) {
			if (!g_strncasecmp ("Any recipient", flt->in, 13)) {
				if (!g_strncasecmp ("To:", buffer, 3))
					strcpy (inmatch, "To:");
				if (!g_strncasecmp ("Cc:", buffer, 3))
					strcpy (inmatch, "Cc:");
			} else {
				strcpy (inmatch, flt->in);
			}
			
			if (!g_strncasecmp (inmatch, buffer, strlen (inmatch))) {
				strcut (buffer, 0, strlen (inmatch));
				next_field = FALSE;
				if (flt->type == FLT_REGEX) {
					regerr = regcomp (&regexpat, flt->match, REG_EXTENDED | REG_NEWLINE | REG_ICASE);
					if (regerr) {
						/* regerror gets called twice to get the full error string 
						   length to do proper posix error reporting */
						reglen = regerror (regerr, &regexpat, 0, 0);
						regmsg = g_malloc0 (reglen + 1);
						regerror (regerr, &regexpat, regmsg, reglen);
						fprintf (stderr, "Regex error in filter %s: %s\n", flt->name, regmsg);
						g_free (regmsg);
						regfree (&regexpat);
					}
				}
				
				do {
					g_strstrip (buffer);
					switch (flt->type) {
					case FLT_REGEX:
						if (!regerr) {
							fltmatch = g_malloc0 ((sizeof (regmatch_t)) * regexpat.re_nsub);
							if (regexec (&regexpat, buffer, regexpat.re_nsub, fltmatch, 0) == 0) {
								/* force free regex memory here to clean up before the 
								   function exits */
								g_free (fltmatch);
								regfree (&regexpat);
								
								if (flt->negate == 0) {
									matched = flt->action;
									goto out;
								}
							}
							else {
								g_free (fltmatch);
								if (flt->negate == 1) {
									matched = flt->action;
									goto out;
								}
							}
						}
						break;
					case FLT_GLOB: 
						/* Not using FNM_CASEFOLD so this won't break 
						   non-GNU systems. */
						if (fnmatch (flt->match, buffer, 0) == 0) {
							if (flt->negate == 0) {
								matched = flt->action;
								goto out;
							}
						} else if (flt->negate == 1) {
							matched = flt->action;
							goto out;
						}
						break;
					case FLT_NORMAL:
						/* fall through */
					default:
						if (strstrcase (buffer, flt->match) != NULL) {
							if (flt->negate == 0) {
								matched = flt->action;
								goto out;
							}
						/* we couldn't find the search string, but if they wanted
						 * a match when it wasn't found, we obey.
						 * The same goes for regex and glob search.  */
						} else if (flt->negate == 1) {
							matched = flt->action;
							goto out;
						}
						break;
					}
					/* lets peek at the next char */
					c = fgetc (file);
					if (c != '\t' && c != ' ')
						next_field = TRUE; /* the next line starts a new field... */
					ungetc (c, file); /* put the char back in the stream */
					if (!next_field) {
						memset (buffer, 0, sizeof (buffer));
						fgets (buffer, sizeof (buffer)-1, file);
					}
				} while (!next_field); /* this is in case the field got wrapped */
				
				if (flt->type == FLT_REGEX) {
					regfree (&regexpat); /* free regex pattern buffer */
				}
			}
		}
		fseek (file, 0, SEEK_SET);
		tmp = tmp->next;
	}
	
 out:
	if (matched) {
		mailbox.name = flt->to;
		mailbox.type = MAILBOX_LOCAL;
		
		switch (matched) {
		case 1: /* move to folder */
			lseek (fd, 0, SEEK_SET);
			if (!mailbox_add_msg_from_file (&mailbox, fd))
				fprintf (stderr, "filters::mailbox_add_msg_from_file (): failed.\n");
			break;
		case 2: /* forward - not done yet */
			break;
		case 3: /* delete it - dont have to do anything */
			break;
		}
		return 1;
	}
	
	return 0;
}
