/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __INDEX_H__
#define __INDEX_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <glib.h>

struct Index;
typedef struct Index Index_t;

Index_t *index_new (void);

void index_free (gpointer key, gpointer user_data);

guint32 index_get_pos (const Index_t *index);

void index_set_pos (Index_t *index, const guint32 pos);

guint32 index_get_size (const Index_t *index);

void index_set_size (Index_t *index, const guint32 size);

gchar *index_get_sender (const Index_t *index);

void index_set_sender (Index_t *index, gchar *sender);

gchar *index_get_subject (const Index_t *index);

void index_set_subject (Index_t *index, gchar *subject);

gchar *index_get_date (const Index_t *index);

void index_set_date (Index_t *index, gchar *date);

gboolean index_get_seen (const Index_t *index);

void index_set_seen (Index_t *index, const gboolean seen);

gchar *index_get_msg (const Index_t *index);

void index_set_msg (Index_t *index, gchar *msg);

void index_unset_msg (Index_t *index);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
