/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __INDEX_LOCAL_H__
#define __INDEX_LOCAL_H__

#ifdef __cplusplus
extern "C" {
#endif

void index_local_init (void);

void index_local_free (void);

void index_local_commit (void);

GList *index_local_load (const Mailbox_t *mbox);

void index_local_create (const Mailbox_t *mbox);

Index_t *index_local_add_msg (const Mailbox_t *mbox, const gchar *msg);

gchar *index_local_get_location (const Mailbox_t *mbox);

gchar *index_local_get_idx_location (const Mailbox_t *mbox);

Index_t *index_local_get_index (const Mailbox_t *mbox, guint i);

gchar *index_local_get_msg (const Mailbox_t *mbox, Index_t *index);

/*gboolean index_local_del_msg (const Mailbox_t *mbox, Index_t *index);*/

gboolean index_local_del_msgs (const Mailbox_t *mbox, GList *unsorted_list);

guint index_local_get_size (const Mailbox_t *mbox);

guint index_local_get_unread (const Mailbox_t *mbox);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
