/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __MESG_H__
#define __MESG_H__

#include <glib.h>
#include <sys/types.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define HEADER_TRIMLEVEL_KEEP_NONE    0
#define HEADER_TRIMLEVEL_KEEP_PARTIAL 1
#define HEADER_TRIMLEVEL_KEEP_ALL     2

guint mesg_get_header_len (const char *mesg);

gchar *mesg_get_trimmed_header (const char *mesg, int trim_level, size_t hdrlen);

gchar *mesg_trim_header (const char *message, int trim_level);

gchar *mesg_get_header_field (const char *message, const char *field);

gchar *mesg_strip_header (char *message);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
