/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef __G_MMAP_H__
#define __G_MMAP_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <glib.h>
#include <unistd.h>
#include <sys/mman.h>

#ifndef MAP_FAILED
#define MAP_FAILED GINT_TO_POINTER (-1)
#endif

#ifndef PROT_READ
#define PROT_READ O_RDONLY
#endif

#ifndef MAP_PRIVATE
#define MAP_PRIVATE
#endif

void *g_mmap (void *start, size_t length, gint prot, gint flags, gint fd, off_t offset);

gint g_munmap (void *start, size_t length);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
