/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __PGP_H__
#define __PGP_H__

#ifdef PGP_PROGRAM

#ifdef __cplusplus
extern "C" {
#pragma }
#endif /* __cplusplus */

#include <gtk/gtk.h>
#undef MIN
#undef MAX
#include "gtkmanip.h"
#include "parse.h"
#include "spruce-exception.h"

GtkWidget *create_dlgPassphrase (GtkWidget *composer);

void on_dlgPassphrase_destroy (GtkWidget *widget, gpointer user_data);

void on_cmdPgpOK_clicked (GtkWidget *widget, gpointer user_data);

gboolean pgp_detect (gchar *text);

gboolean pgp_sign_detect (gchar *text);

gboolean pgp_recipient_exists (gchar *email);

char *pgp_decrypt (const char *ciphertext, const char *passphrase, SpruceException *ex);

char *pgp_encrypt (const char *plaintext, const char *recipients, const char *passphrase,
		   gboolean sign, SpruceException *ex);

char *pgp_clearsign (const char *plaintext, const char *userid, const char *passphrase,
		     SpruceException *ex);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* PGP_PROGRAM */

#endif
