/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  Spruce
 *  Copyright (C) 1999-2000 Jeffrey Stedfast
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* Coded to be compliant with RFC 1725 (Post Office Protocol - Version 3) */

#ifndef __POP3IO_H__
#define __POP3IO_H__

#ifdef __cplusplus
extern "C" {
#pragma }
#endif /* __cplusplus */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*#include <sys/stat.h>*/
/*#include <sys/uio.h>*/
#include <unistd.h>
#include <sys/wait.h>
#include <sys/un.h>
/*#include <sys/param.h>*/
#undef MIN
#undef MAX
#include <glib.h>

#include "defines.h"
#include "parse.h"
#include "sockio.h"
#include "server.h"
#include "status.h"
#include "globals.h"
#include "mailbox.h"
#include "md5.h"
#include "accounts_t.h"
#include "cram-md5.h"
#include "spruce-exception.h"

/* version information for pop3io */
#define P_VER_MAJOR '0'
#define P_VER_MINOR '6'
#define P_VER_REL   '1'


struct _emessage_
{
	gchar *header;
	gchar *body;
};

typedef struct _emessage_ Emesg;

/* grrr, we need these here because we cant include main.h */
void invoke_in_gui_thread (GtkFunction func, gpointer data);

gint mailthread_update_status_progress (gpointer data);

gint mailthread_update_status_text (gpointer data);

void emesg_destroy (Emesg *msg);

gint fetchmail (Server *server, gchar *login, gchar *passwd, Mailbox_t *finbox, 
		gboolean del_yn, gboolean show_dialog, conn_auth_t authtype,
		gboolean useSSL, SpruceException *ex);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __POP3IO_H__ */
