/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  spruce-ssl.c - SSL support for Spruce
 *  Copyright (C) 2000 Erik Forsberg
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef _SPRUCE_SSL_H
#define _SPRUCE_SSL_H

#include "config.h"
#include <gtk/gtk.h>
#ifdef WITH_SSL
#include <openssl/ssl.h>
#include <openssl/ssl2.h>

struct sslPair {
	int sock;
	SSL *sslStruct;
	struct sslPair *next;
};

void registerSSL (int sock, SSL *sslStruct);
SSL *getSSL (int sock);
void deregisterSSL (int sock);
void sslInit (void);
int verifyCallback (int ok, X509_STORE_CTX *ctx);
int openSSLConnection (gint sockfd);
void closeSSLConnection (gint sockfd);
int verifySSLConnection (gint sockfd);

#else 
#include <sys/types.h>

#endif /* WITH_SSL */

ssize_t SSLSend(gint socket, gchar *buffer, gint buflen, gint flags);

#endif /* _SPRUCE_SSL_H */
